 module netk 
 implicit none
!experimental spectra for different thicknesses must be given in separate
! files (see below) 
!
! all files containing the experimental spectra
! require the same number and values of frequencies (in cm-1)
!
  public
  integer ic,nlamda,nd,nlamdamin1,nlamdamin2,nlamdamax1,nlamdamax2
  integer nlamdamin3,nlamdamax3,nlamdamin4,nlamdamax4
! nlamda is the number of lines in the files containing spectra
! nd is the number of spectra considered
  real*8 lamdap,Xexpp1,Xexpp2,Xexpp3,Xexpp4,Xexpp5,Xexpp6,lamdamax,lamdamin
! maximum and minimum value of frequencies
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!! IMPORTANT TO CHANGE!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! lamdamin and lamdamax give the experimental spectral range. nlamda is
! the number of data for each experimental file.
  parameter (lamdamax=3500.34448d0,lamdamin=599.78354d0,nlamda=3009)
! nd is the number of experimental files.
  parameter (nd=4)
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  complex*16 ntot(nlamda),nvoid,Nsub(nlamda),ii
  real*8 Tbckg(nlamda)
  real*8 NNsub(nlamda),NNtot(nlamda),Nktot(nlamda),Nktotder(nlamda)
  real*8 ddd(nd),dddbon(nd)
  real*8 c(nd),nu0,n000,n0new
  real*8 pi,theta0,theta1,theta2,ctheta0,ctheta1,ctheta2
  real*8 Xexp0(nlamda,nd),Xexp(nlamda,nd),XXexp(nd),Xtheo(nlamda,nd),lamda(nlamda)
  complex*16 delta1, deltaphi1
  real*8 aaa, shift(nlamda)
!  
  contains
!------------------------------------------------------------------------------!
  subroutine  readspectra
! routine initializing parameters and
! reading the files containing the experimental spectra
!
    integer i
      ii=dcmplx(0,1.d0)
      nvoid=dcmplx(1.d0,0.d0)
      pi=dacos(-1.d0)
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! IMPORTANT give the name of the files containing the spectra
      open(10,file='01_MIR_1_21may.dat',status='old')
      open(20,file='01_MIR_2_21may.dat',status='old')
      open(30,file='01_MIR_3_21may.dat',status='old')
      open(40,file='01_MIR_4_21may.dat',status='old')
! IMPORTANT: enter the angle of incidence theta0
! actually, program works only for theta0=0
      theta0=0.d0
      theta1=0.d0
      theta2=0.d0
      ctheta0=dcos(theta0)
      ctheta1=dcos(theta1)
      ctheta2=dcos(theta2)
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! IMPORTANT: enter the indices of frequencies  of 4 ranges of low absorption
       nlamdamin1=1
       nlamdamax1=326
       nlamdamin2=470
       nlamdamax2=840
       nlamdamin3=1180
       nlamdamax3=2448
       nlamdamin4=3000
       nlamdamax4=3009
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! IMPORTANT: enter the first estimation of n0
       n000=1.475d0
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!  
! IMPORTANT: enter the first estimation of different thickness in meters 
! in the same order of the read files
      ddd(1)=220.07d-9
      ddd(2)=440.15d-9
      ddd(3)=660.23d-9
      ddd(4)=880.30d-9
      dddbon=ddd

! enter coherences
      c(1)=1.d0
      c(2)=1.d0
      c(3)=1.d0
      c(4)=1.d0
       i=0
       do ic=1,nlamda
         read(10,*) lamdap,Xexpp1
! compute the refraction indic of the substrate at the given frequencies
         read(20,*) lamdap,Xexpp2
         read(30,*) lamdap,Xexpp3
         read(40,*) lamdap,Xexpp4
!         if (ic/1*1.eq.ic) then
           i=i+1
           lamda(i)=lamdap
           Xexp(i,1)=Xexpp1
           Xexp(i,2)=Xexpp2
           Xexp(i,3)=Xexpp3
           Xexp(i,4)=Xexpp4
           NNsub(i)=refindSi(lamda(i))
           Nsub(i)=dcmplx(NNsub(i),0.d0)
!         endif
       end do
       Xexp0=Xexp

       close(10)
       close(20)
       close(30)
       close(40)
  end subroutine readspectra
!------------------------------------------------------------------------------!
   subroutine kramkron
! Kramers-Kronig equation
    implicit none
    integer i,m
    real*8 integ,integ1,integ2,eps
    parameter (eps=1.d-2)

         call spline(lamda,Nktot,nlamda,0.d0,0.d0,Nktotder)
         do i=1,nlamda
         nu0=lamda(i)
         if(nu0.eq.lamda(1)) then
            do m=1,13
         call midpoint(kmk,nu0+eps,lamdamax,integ,m)
            enddo
         elseif (nu0.eq.lamda(nlamda)) then
            do m=1,13
             call midpoint(kmk,lamdamin,nu0-eps,integ,m)
            enddo
         else
            do m=1,13
             call midpoint(kmk,lamdamin,nu0-eps,integ1,m)
            enddo
            do m=1,13
              call midpoint(kmk,nu0+eps,lamdamax,integ2,m)
            enddo
         integ=integ1+integ2
         endif
         NNtot(i)=n000+2.d0/pi*integ
         Ntot(i)=dcmplx(NNtot(i),Nktot(i))
         enddo
  end subroutine kramkron
!-------------------------------------------------------------------------------
      real*8 function granR12(n1,n2,theta11,theta22)
       implicit none
       real*8 theta11,theta22,ctheta11,ctheta22
       complex*16 n1,n2,r12
        ctheta11=dcos(theta11)
        ctheta22=dcos(theta22)

      r12= (ctheta11-ctheta22*n2/n1)/(ctheta11+ctheta22*n2/n1)
      granR12= (abs(r12))**2
        return
      end function
!-------------------------------------------------------------
      subroutine spectrabckg(TTbckg)
!  calculation of background spectra of substrate 
      implicit none
      integer i
      complex*16 rbckg01(nlamda),rbckg10(nlamda)
      complex*16 tbckg01(nlamda),tbckg10(nlamda)
      real*8 Rbckg(nlamda),TTbckg(nlamda)
!  calculation of transmission and reflexion coefficients of substrate
      do i=1,nlamda
      rbckg01(i)= (dcmplx(ctheta0,1.d0) -dcmplx(ctheta1,0.d0)* &
      Nsub(i)/nvoid)/(dcmplx(ctheta0,0.d0)+dcmplx(ctheta1,0.d0) &
           *Nsub(i)/nvoid)

      rbckg10(i)=  (ctheta1-ctheta0*nvoid/Nsub(i))/(ctheta1+ctheta0*nvoid/Nsub(i))

      Rbckg(i)=abs(rbckg10(i)*rbckg10(i))


      tbckg01(i)=  (2.d0*ctheta0)/(ctheta0+ctheta1*Nsub(i)/nvoid)

      tbckg10(i)=  (2.d0*ctheta1)/((ctheta1+nvoid/Nsub(i))*ctheta0)

      TTbckg(i)=abs(tbckg01(i)*tbckg01(i))*abs(tbckg10(i)*tbckg10(i))/(1.d0-Rbckg(i)*Rbckg(i))
      enddo
       return
      end subroutine spectrabckg
!-------------------------------------------------------------
      subroutine spectratot(NNNtot,NNNsub,TTbckg,dddd,llamda,cc,XXXtheo)
!  calculation of theoretical spectra Xtheo=Tspec/Tbckg
      implicit none
      integer i
      complex*16 NNNtot,NNNsub,ptiTspec01,ptiTspec12
      complex*16 ptiTspec10,ptiTspec21
      complex*16 Tspec01,Tspec12,Tspec10
      complex*16 Tspec21
      complex*16 ptiRspec01,ptiRspec12
      complex*16 ptiRspec10,ptiRspec21
      real*8 Rf1,Rf2,Rf1nc,Rf2nc,dddd
      real*8 Tf1,Tf2,Tf1nc,Tf2nc
      real*8 TTspec,TTbckg,TTc,TTnc
      real*8 Rspec,Rbckg
      real*8 Rspec01,Rspec12,Rspec10,Rspec21
      real*8 wlength
      real*8 XXXtheo,llamda,cc


        wlength= 1.d0/(llamda*100.d0)

      Rspec01= granR12(nvoid,NNNtot,theta0,theta1)
      Rspec10= granR12(NNNtot,Nvoid,theta1,theta2)
      Rspec12= granR12(NNNtot,NNNsub,theta1,theta2)
      Rspec21= granR12(NNNsub,NNNtot,theta0,theta1)


      ptiRspec01= (ctheta0-ctheta1*nnntot/nvoid)/(ctheta0+ctheta1*nnntot/nvoid)

      ptiRspec10=  (ctheta1-ctheta0*nvoid/nnntot)/(ctheta1+ctheta0*nvoid/nnntot)

      ptiRspec12= (ctheta1-ctheta2*NNNsub/nnntot)/(ctheta1+ctheta2*NNNsub/nnntot)

      ptiRspec21= (ctheta2-ctheta1*nnntot/NNNsub)/(ctheta2+ctheta1*nnntot/NNNsub)

      ptiTspec01= 2.d0*ctheta0/(ctheta0+ctheta1*nnntot/nvoid)
      Tspec01=REAL(NNNtot)*ctheta1/(REAL(nvoid)*ctheta0)*abs(ptiTspec01*ptiTspec01)

      ptiTspec10=  2.d0*ctheta1/(ctheta1+ctheta0*nvoid/nnntot)
      Tspec10=REAL(Nvoid)*ctheta0/(REAL(nnntot)*ctheta1)*abs(ptiTspec10*ptiTspec10)

      ptiTspec12= 2.d0*ctheta1/(ctheta1+ctheta2*NNNsub/nnntot)
      Tspec12=REAL(NNNsub)*ctheta2/(REAL(nnntot)*ctheta1)*abs(ptiTspec12*ptiTspec12)

      ptiTspec21= 2.d0*ctheta2/(ctheta2+ctheta1*nnntot/NNNsub)
      Tspec21=REAL(NNNtot)*ctheta1/(REAL(nNNsub)*ctheta2)* abs(ptiTspec21*ptiTspec21)


      delta1= (2.d0*pi/wlength)*dddd*nnntot/sqrt(1.d0-(dsin(theta0))**2/(NNNtot)**2)
      deltaphi1=(4.d0*pi/wlength)*dddd*nnntot * sqrt(1.d0-(dsin(theta0))**2/(NNNtot)**2)

!     coherent

      Tf1= REAL(NNNsub)*ctheta2/(REAL(nvoid)*ctheta0)* &
        (abs(ptiTspec01*ptiTspec12*exp(ii*delta1)   &
        /(1.d0+ptiRspec01*ptiRspec12*exp(ii*deltaphi1))))**2

      Tf2=REAL(nvoid)*ctheta0/(REAL(NNNsub)*ctheta2)*   &
         (abs(ptiTspec21*ptiTspec10*exp(ii*delta1)    &
        /(1.d0+ptiRspec21*ptiRspec10*exp(ii*deltaphi1))))**2

       Rf1= (abs(-(ptiRspec12+ptiRspec01*exp(ii*deltaphi1))/  &
      (1.d0+ ptiRspec12*ptiRspec01*exp(ii*deltaphi1))))**2

       Rf2= (abs((ptiRspec21+ptiRspec10*exp(ii*deltaphi1))/   &
      (1.d0+  ptiRspec21*ptiRspec10*exp(ii*deltaphi1))))**2

      TTc= Tf1*Tf2/(1.d0-Rf1*Rf2)
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!       
!    non coherent
!Delia
       Tf1nc=REAL(NNNsub)*ctheta2/(REAL(nvoid)*ctheta0)*   &
       Tspec01*Tspec12*exp(-2.d0*aimag(delta1))/         &
       (1.d0-Rspec10*Rspec12*exp(-2.d0*aimag(deltaphi1)))

       Tf2nc=REAL(Nvoid)*ctheta0/(REAL(nNNsub)*ctheta2)*   &
       Tspec21*Tspec10*exp(-2.d0*aimag(delta1))/         &
       (1.d0-Rspec12*Rspec10*exp(-2.d0*aimag(deltaphi1)))

      Rf1nc=Rspec21+Tspec21*Tspec12*Rspec10*exp(-2.d0*aimag(deltaphi1))/   &
           (1.d0-Rspec12*Rspec10*exp(-2.d0*aimag(deltaphi1)))

       Rf2nc=Rf1nc

       TTnc=Tf1nc*Tf2nc/(1.d0-Rf1nc*Rf2nc)

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
      TTspec= cc*TTc+(1.d0-cc)*TTnc

      XXXtheo=-dlog10(TTspec/TTbckg)
      end subroutine spectratot
!--------------------------------------------------------------------
      real*8 function kmk(nu)
! imaginary part of refraction indice k in function of the wavenumber

      implicit none
!!!
        real*8 nu,kkk

         call splint(lamda,Nktot,Nktotder,nlamda,nu,kkk)
         kmk= nu*kkk/(nu*nu-nu0*nu0)
         return
       end function kmk

!-----------------------------------------------------
      subroutine midpoint(func,a,b,s,n)
!  routine to integrate singular functions
        implicit none
        integer n
        real*8 a,b,s,func
        external func
        integer it,j
        real*8 ddel,del,summ,tnm,x
!
         if(n.eq.1) then
          s=(b-a)*func(0.5d0*(a+b))
         else
          it=3**(n-2)
          tnm=dfloat(it)
          del=(b-a)/(3.d0*tnm)
          ddel=del+del
          x=a+0.5d0*del
          summ=0.d0
          do j=1,it
           summ=summ+func(x)
           x=x+ddel
           summ=summ+func(x)
           x=x+del
          enddo
         s=(s+(b-a)*summ/tnm)/3.d0
         endif
         return
        END subroutine midpoint 
!----------------------------------------------------
       SUBROUTINE spline(x,y,n,yp1,ypn,y2)
       INTEGER n,NMAX
       real*8 yp1,ypn,x(n),y(n),y2(n)
       PARAMETER (NMAX=5000)
!Given arrays x(1:n) and y(1:n) containing a tabulated function, i.e., yi = f(xi), with
!x1 < x2 < .. . < xN, and given values yp1 and ypn for the first derivative of the interpolating
!function at points 1 and n, respectively, this routine returns an array y2(1:n) of
!length n which contains the second derivatives of the interpolating function at the tabulated
!points xi. If yp1 and/or ypn are equal to 1 × 1030 or larger, the routine is signaled to set
!the corresponding boundary condition for a natural spline, with zero second derivative on
!that boundary.
!Parameter: NMAX is the largest anticipated value of n.
       INTEGER i,k
       real*8 p,qn,sig,un,u(NMAX)
!       write(*,*) 'spline',x,n,yp1,ypn
       if (yp1 .gt. .99d30) then         !The lower boundary condition is set either to be
          y2(1)=0.                     !natural
          u(1)=0.
       else                            !or else to have a specified first derivative.
          y2(1)=-0.5
          u(1)=(3./(x(2)-x(1)))*((y(2)-y(1))/(x(2)-x(1))-yp1)
       endif
       do  i=2,n-1                   !This is the decomposition loop of the tridiagonal
                                       !algorithm. y2 and u are used for temporary
                                       !storage of the decomposed factors.
          sig=(x(i)-x(i-1))/(x(i+1)-x(i-1))
          p=sig*y2(i-1)+2.
          y2(i)=(sig-1.)/p
          u(i)=(6.*((y(i+1)-y(i))/(x(i+1)-x(i))-(y(i)-y(i-1)) &
          /(x(i)-x(i-1)))/(x(i+1)-x(i-1))-sig*u(i-1))/p
       enddo
       if (ypn.gt..99d30) then         !The upper boundary condition is set either to be
          qn=0.                        !natural
          un=0.
       else                            !or else to have a specified first derivative.
          qn=0.5
          un=(3./(x(n)-x(n-1)))*(ypn-(y(n)-y(n-1))/(x(n)-x(n-1)))
       endif
       y2(n)=(un-qn*u(n-1))/(qn*y2(n-1)+1.)
       do k=n-1,1,-1                !This is the backsubstitution loop of the tridiagonal algorithm.
           y2(k)=y2(k)*y2(k+1)+u(k)
       enddo
       return
       END subroutine spline
!---------------------------------------------------------------------------------
       SUBROUTINE splint(xa,ya,y2a,n,x,y)
       INTEGER n
       double precision x,y,xa(n),y2a(n),ya(n)
!Given the arrays xa(1:n) and ya(1:n) of length n, which tabulate a function (with the
!xais in order), and given the array y2a(1:n), which is the output from spline above,
!and given a value of x, this routine returns a cubic-spline interpolated value y.
       INTEGER k,khi,klo
       double precision a,b,h
       klo=1        !We will find the right place in the table by means of bisection.
                    !This is optimal if sequential calls to this routine are at random
                    !values of x. If sequential calls are in order, and closely
                    !spaced, one would do better to store previous values of
                    !klo and khi and test if they remain appropriate on the
                    !next call.
       khi=n
!      write(*,*)  'splint',xa,ya,y2a,n,x
 1     if (khi-klo.gt.1) then
          k=(khi+klo)/2
          if(xa(k).gt.x)then
             khi=k
          else
             klo=k
          endif
          goto 1
       endif         !klo and khi now bracket the input value of x.
       h=xa(khi)-xa(klo)
       if (h.eq.0.) stop 'bad xa input in splint'
! The xas must be distinct.
           a=(xa(khi)-x)/h
!Cubic spline polynomial is now evaluated.
           b=(x-xa(klo))/h
           y=a*ya(klo)+b*ya(khi)+((a**3-a)*y2a(klo)+(b**3-b)*y2a(khi))*(h**2)/6.
      return
      END subroutine splint
!----------------------------------------------------------------------
      real*8 function refindSi(x)
!  return refraction indice of Si for a given wave number X in cm-1
        implicit none
        real*8 x

          refindSi=3.39224d0-1.54919d-6*x+1.60505d-09*x*x    ! 30K - 2000-9000cm
!          refindSi=3.419d0+8.38248d-07*x+1.23003d-09*x*x    ! 298K- 500-4000cm
        return
        end function refindSi
!----------------------------------------------------------------------
      real*8 function funmeritD(N,K,NNNsub,TTbckg,llamda,XXXexp)
! MERIT function summed over all spectra for omne given frequencie
! requires as an entry :
! -N and K :the real & imaginary part of refraction indice at given frequencie
! -NNNSUB : complex refraction indice of substrate
! -TTbckg : background spectra at given frequencie
! -llamda : frequencie of interest  
! -XXXexp : vector containing experimental transmission of all spectra 
!           at frequencie llamda 
        implicit none
        integer i
        real*8 N,K,XXXtheo, XXXexp(nd),TTbckg,llamda
        complex*16 NNNtot,NNNsub

       NNNtot=dcmplx(N,K)
       funmeritD=0.d0
!          write(*,*) '#in merit'
      do i=1,nd
      call spectratot(NNNtot,NNNsub,TTbckg,dddbon(i),llamda,c(i),XXXtheo)

       funmeritD=funmeritD+((XXXtheo-XXXexp(i))/dddbon(i))**2
      enddo
      return
      end function funmeritD
!---------------------------------------------------------------------
       subroutine steepestK(N,K,NNNsub,TTbckg,llamda,XXXexp,kk)
! minimize MERIT function optimizing best k value at each frequency
! requires as an entry :
! -N and K :the real & imaginary part of refraction indice at given frequencie
! -NNNSUB : complex refraction indice of substrate
! -TTbckg : background spectra at given frequencie
! -llamda : frequencie of interest  
! -XXXexp : vector containing experimental transmission of all spectra at given llamda
        implicit none
        integer i,rep
        real*8 n,k,kk,llamda,TTbckg
        real*8 XXXexp(nd),epsil,gra,p,m,thrsh,eta
        real*8 direc,direc2
        complex*16 NNNsub

! IMPORTANT : convergence parameters
         epsil= 1.d-6                !  derivative step
         thrsh= 1.d-5                !  convergence desired
         eta= 1.d-1

         kk=k
        if(kk.lt.epsil) then
         p=funmeritD(N,KK+epsil,NNNsub,TTbckg,llamda,XXXexp)
         m=funmeritD(N,KK,NNNsub,TTbckg,llamda,XXXexp)
         gra= (p-m)/(epsil)
        else
         p=funmeritD(N,KK+epsil,NNNsub,TTbckg,llamda,XXXexp)
         m=funmeritD(N,KK-epsil,NNNsub,TTbckg,llamda,XXXexp)
         gra= (p-m)/(2.d0*epsil)
        endif
         direc=gra/(abs(gra))
         i=0
         rep=0
       do while (eta.gt.thrsh.and.i.lt.1000)
         i=i+1
         if(i.ge.2) direc=direc2
          kK= Kk-direc*eta
        if (kk.lt.0.d0) kk=0.d0
        if(kk.lt.epsil) then
         p=funmeritD(N,KK+epsil,NNNsub,TTbckg,llamda,XXXexp)
         m=funmeritD(N,KK,NNNsub,TTbckg,llamda,XXXexp)
         gra= (p-m)/(epsil)
        else
         p=funmeritD(N,KK+epsil,NNNsub,TTbckg,llamda,XXXexp)
         m=funmeritD(N,KK-epsil,NNNsub,TTbckg,llamda,XXXexp)
         gra= (p-m)/(2.d0*epsil)
        endif
         direc2=gra/(abs(gra))
        if((direc*direc2).lt.0) eta= 0.1d0*eta

          if(i.eq.1000) then
            write(22,*) '#maxit in steepest,', gra,kk,llamda
            kk=k
          endif
       enddo
        end subroutine steepestK
!---------------------------------------------------------------------
      real*8 function funmeritL(dddd,cc,XXXexp)
! MERIT function summed over all frequencies for a given thickness
! requires as entry :
! dddd: thickness associated to the desired spectra
! cc :  coherence associated to the desired spectra
! XXXexp : vector containing experimental transmission of all frequencies for a given spectra
        implicit none
        integer i
        real*8 dddd,XXtheo(nlamda), cc,XXXexp(nlamda)

       funmeritL=0.d0
!          write(*,*) '#in merit'
      do i=1,nlamda
      call spectratot(Ntot(i),Nsub(i),Tbckg(i),dddd,lamda(i),cc,XXtheo(i))

       funmeritL=funmeritL+((XXtheo(i)-XXXexp(i))/dddd)**2
      enddo
      return
      end function funmeritL
!---------------------------------------------------------------------
      real*8 function funmeritL2(dddd,cc,XXXexp,lmin,lmax)
! MERIT function summed over in a range of frequencies for a given thickness
! requires as entry :
! dddd: thickness associated to the desired spectra
! cc :  coherence associated to the desired spectra
! XXXexp : vector containing experimental transmission of all frequencies for a given spectra
!lmin,lmax : indices of limit frequencies
        implicit none
        integer i,lmin,lmax
        real*8 dddd,XXtheo(nlamda), cc,XXXexp(nlamda)

       funmeritL2=0.d0
!          write(*,*) '#in merit'
      do i=lmin,lmax
      call spectratot(Ntot(i),Nsub(i),Tbckg(i),dddd,lamda(i),cc,XXtheo(i))

       funmeritL2=funmeritL2+((XXtheo(i)-XXXexp(i))/dddd)**2
      enddo
      return
      end function funmeritL2

!---------------------------------------------------------------------
       subroutine steepestD(dddd,cc,XXXexp,dddnew)
! minimize MERIT function optimizing best thickness 
! requires as entry :
! dddd: thickness associated to the desired spectra
! cc :  coherence associated to the desired spectra
! XXXexp : vector containing experimental transmission of all frequencies for a given spectra
       implicit none
       integer i,rep
       real*8 dddd,Xtheo(nlamda)
       real*8 XXXexp(nlamda),cc,epsil,gra,p,m,thrsh
       real*8 direc,direc2,dddnew,eta

!!!!!! IMPORTANT     convergence parameters
         epsil= 1.d-13        !  derivative step
         thrsh= 1.d-11        !  convergence desired
         eta= 1.d-8

         dddnew=dddd
         p=funmeritL(dddnew+epsil,cc,XXXexp)
         m=funmeritL(dddnew-epsil,cc,XXXexp)

         gra= (p-m)/(2.d0*epsil)
         write (6,*) p,m,gra,epsil
         direc=gra/(abs(gra))
         i=0
         do while (eta.gt.thrsh.and.i.lt.1000)
         i=i+1
         if(i.ge.2) direc=direc2
            dddnew= dddnew-eta*direc
         p=funmeritL(dddnew+epsil,cc,XXXexp)
         m=funmeritL(dddnew-epsil,cc,XXXexp)
         gra= (p-m)/(2.d0*epsil)
         direc2=gra/(abs(gra))
         if((direc*direc2).lt.0) eta= 0.1d0*eta

          if(i.eq.1000.and.rep.eq.0) then
            rep=1
            i=950
            write(22,*) '#maxit in steepestD,', gra,dddnew,lamda
          endif
!            if (rep.eq.1) write(75,*) i,kk, gra,p,m 
         enddo
!         write(*,*)  '# steepest, iter=',i, gra
        end subroutine steepestD
!---------------------------------------------------------------------
       subroutine steepestC(dddd,cc, XXXexp,cnew)
! minimize MERIT function optimizing best coherence 
! requires as entry :
! dddd: thickness associated to the desired spectra
! cc :  coherence associated to the desired spectra
! XXXexp : vector containing experimental transmission of all frequencies for a given spectra
       implicit none
       integer i,rep
       real*8 dddd, XXXexp(nlamda),cc,epsil,gra,p,m,thrsh
       real*8  direc,direc2,cnew,eta

!!!!!! IMPORTANT     convergence parameters
         epsil= 1.d-4        !  derivative step
         thrsh= 1.d-3        !  convergence desired
         eta= 1.d-1

         cnew=cc
        if(cnew.gt.(1.d0-epsil)) then
         p=funmeritL(dddd,cnew,XXXexp)
         m=funmeritL(dddd,cnew-epsil,XXXexp)
         gra= (p-m)/(epsil)
        elseif(cnew.lt.epsil) then
         p=funmeritL(dddd,cnew+epsil,XXXexp)
         m=funmeritL(dddd,cnew,XXXexp)
         gra= (p-m)/(epsil)
        else
         p=funmeritL(dddd,cnew+epsil,XXXexp)
         m=funmeritL(dddd,cnew-epsil,XXXexp)
         gra= (p-m)/(2.d0*epsil)
        endif
         direc=gra/(abs(gra))

         i=0

        do while (eta.gt.thrsh.and.i.lt.1000.and.cnew.ge.0.d0)
         i=i+1
         if(i.ge.2) direc=direc2
            cnew= cnew-eta*direc

        if(cnew.gt.(1.d0-epsil)) then
         p=funmeritL(dddd,cnew,XXXexp)
         m=funmeritL(dddd,cnew-epsil,XXXexp)
         gra= (p-m)/(epsil)
        elseif(cnew.lt.epsil) then
         p=funmeritL(dddd,cnew+epsil,XXXexp)
         m=funmeritL(dddd,cnew,XXXexp)
         gra= (p-m)/(epsil)
        else
         p=funmeritL(dddd,cnew+epsil,XXXexp)
         m=funmeritL(dddd,cnew-epsil,XXXexp)
         gra= (p-m)/(2.d0*epsil)
        endif

         direc2=gra/(abs(gra))
        if((direc*direc2).lt.0) eta= 0.1d0*eta

          if(i.eq.1000) then
            write(22,*) '#maxit in steepestC,', gra,cnew,lamda
          endif
         enddo
          if(cnew.lt.0.d0) cnew=0.d0
          if(cnew.gt.1.d0) cnew=1.d0

        end subroutine steepestC
!---------------------------------------------------------------------
      real*8 function funmeritall(nnntot,lamin,lamax,ndmin,ndmax)
! MERIT function summed over all frequencies and all spectra 
! requires as entry :
! nnntot: vector containing complex refraction indice for all frequencies
! lamin,lamax : limits of frequency range desired
! --> for optimizing n0, recommended to take  ranges without strong absorption
! ndmin,ndmax : min and max value of the spectra desired to be considered 
        implicit none
        integer i,j,lamin,lamax,ndmin,ndmax
        complex*16 nnntot(nlamda)
       funmeritall=0.d0
!          write(*,*) '#in merit'
      do i=lamin,lamax
       do j=ndmin,ndmax
      call spectratot(Nnntot(i),Nsub(i),Tbckg(i),dddbon(j),lamda(i),c(j),Xtheo(i,j))
       funmeritall=funmeritall+((Xtheo(i,j)-Xexp(i,j))/dddbon(j))**2
       enddo
      enddo
      return
      end function funmeritall
!---------------------------------------------------------------------
       subroutine steepestN(n00,lamin1,lamax1,lamin2,lamax2,n0new)
! minimize MERIT function optimizing best n0 value 
! requires as entry :
! n00 : the n0 value to be optimized
! this routine works with 2 ranges
! if only 1 range is desired, it has to be divided
! lamin1,lamax1 : 1st range of frequencies
! lamin2,lamax2 : 2nd range of frequencies

       implicit none
       integer i,j,rep,lamin1,lamax1,lamin2,lamax2
       real*8 epsil,gra,p,m,direc,direc2,n0new,n00,eta,thrsh,temp
       complex*16 Nplus(nlamda),Nmoins(nlamda)

! IMPORTANT    convergence parameter
         epsil= 1.d-5        !  derivative step
         thrsh= 1.d-4        !  convergence desired
         eta= 1.d-1

         n0new=n00
         do j=1,nlamda
          temp= real(ntot(j))+epsil
          nplus(j)= dcmplx(temp,aimag(ntot(j)))
          temp= real(ntot(j))-epsil
          nmoins(j)= dcmplx(temp,aimag(ntot(j)))
         enddo

         p=funmeritall(nplus,lamin1,lamax1,1,nd)
         p=p+funmeritall(nplus,lamin2,lamax2,1,nd)

         m=funmeritall(nmoins,lamin1,lamax1,1,nd)
         m=m+funmeritall(nmoins,lamin2,lamax2,1,nd)

         gra= (p-m)/(2.d0*epsil)
         direc=gra/(abs(gra))
         i=0
         do while (eta.gt.thrsh.and.i.lt.100)
         i=i+1
         if(i.ge.2) direc=direc2

           n0new=n0new-eta*direc
           do j=1,nlamda
            temp= real(ntot(j))-eta*direc
            Ntot(j)= dcmplx(temp,aimag(ntot(j)))
           enddo
           do j=1,nlamda
            temp= real(ntot(j))+epsil
            nplus(j)= dcmplx(temp,aimag(ntot(j)))
            temp= real(ntot(j))-epsil
            nmoins(j)= dcmplx(temp,aimag(ntot(j)))
           enddo

         p=funmeritall(nplus,lamin1,lamax1,1,nd)
         p=p+funmeritall(nplus,lamin2,lamax2,1,nd)

         m=funmeritall(nmoins,lamin1,lamax1,1,nd)
         m=m+funmeritall(nmoins,lamin2,lamax2,1,nd)

         gra= (p-m)/(2.d0*epsil)
         direc2=gra/(abs(gra))
         if((direc*direc2).lt.0) eta= 0.1d0*eta

          if(j.eq.100) then
            write(22,*) '#maxit in steepestN0,', gra,n0new
          endif
         enddo
        end subroutine steepestN
!---------------------------------------------------------------------
        subroutine initntot
! generate a first guess for complex refraction indice using Lambert equation
        implicit none
        integer i,m,eps
        real*8 wlength,kmin, bord1, bord2, bord3,bord4,bord5,bord6

        kmin=0.d0
        do i=1,nlamda
        wlength= 1.d0/(lamda(i)*100.d0)
          nktot(i)= wlength * Xexp(i,nd) /(2.d0*pi*ddd(nd)*2.3d0)
          if(nktot(i).lt.kmin) kmin=nktot(i)
        enddo

        do i=1,nlamda
          nktot(i)=nktot(i)-kmin
        enddo

        call kramkron
!   writing temporary result in fort.33
        do i=1,nlamda
         write(33,*) lamda(i),NNtot(i), nktot(i)
         Ntot(i)=dcmplx(NNtot(i), nktot(i))
        enddo
!  optimization of initial k
       call optiK(1,nlamda)

!  set k to 0 in low absorbtion regions
!!!!! IMPORTANT   check the location of strong absorbtion bands and adapt
!        do i=1,nlamdamin1-1
!         nktot(i)=nktot(i)-nktot(nlamdamin1)
!        enddo
        bord1=nktot(nlamdamax1-1)
        bord2=nktot(nlamdamin2)
        bord3=nktot(nlamdamax2-1)
        bord4=nktot(nlamdamin3)
        bord5=nktot(nlamdamax4-1)
        bord6=nktot(nlamdamin4)
        do i=nlamdamax1+1,nlamdamin2-1
         nktot(i)=nktot(i)-bord1-(bord2-bord1)/  & 
         (lamda(nlamdamin2)-lamda(nlamdamax1))*(lamda(i)-lamda(nlamdamax1))
        enddo
        do i=nlamdamax2+1,nlamdamin3-1
         nktot(i)=nktot(i)-bord3-(bord4-bord3)/ &
         (lamda(nlamdamin3)-lamda(nlamdamax2))* &
         (lamda(i)-lamda(nlamdamax2))
        end do
        do i=nlamdamax3+1,nlamdamin4-1
         nktot(i)=nktot(i)-bord5-(bord6-bord5)/  &
         (lamda(nlamdamin4)-lamda(nlamdamax3))* &
         (lamda(i)-lamda(nlamdamax3))
        end do
        do i=nlamdamin1,nlamdamax1
        nktot(i)=0.d0
        enddo
        do i=nlamdamin2,nlamdamax2
         nktot(i)=0.d0
        enddo
        do i=nlamdamin3,nlamdamax3
         nktot(i)=0.d0
        end do
        do i=nlamdamin4,nlamdamax4
         nktot(i)=0.d0
        end do
!   Kramers-Kronig to recompute n
       call kramkron


!   writing temporary result in fort.34

        do i=1,nlamda
         write(34,*) lamda(i),NNtot(i), nktot(i)
         Ntot(i)=dcmplx(NNtot(i), nktot(i))
        enddo
        end subroutine initntot 
!---------------------------------------------------------------------
       subroutine chopab(XXXtheo,XXXexp,a,b)
! optimize a and b, lineal parameters for the offset of each spectra 
! requires in entry :
! XXXtheo : vector containing theoretical spectrum for all frequencies
! XXXexp : vector containing experimental spectrum for all frequencies
       implicit none
       integer i
       real*8 XXXtheo(nlamda),aold,bold
       real*8 XXXexp(nlamda),gra,pa,ma,pb,mb,thrsha,a,b
       real*8 sigmaX,sigmaX2,sigmaY,sigmaXY

        sigmaX=0.d0
        sigmaX2=0.d0
        sigmaY=0.d0
        sigmaXY=0.d0
        do i=1,nlamda
         sigmaX=sigmaX+lamda(i)
         sigmaX2=sigmaX2+lamda(i)*lamda(i)
         sigmaY=sigmaY+(XXXtheo(i)-XXXexp(i))
         sigmaXY=sigmaXY+(XXXtheo(i)-XXXexp(i))*lamda(i)
        enddo

         a=sigmaX*sigmaY-dfloat(nlamda)*sigmaXY
         a=a/(sigmaX*sigmaX-dfloat(nlamda)*sigmaX2)

         b=(sigmaY-a*sigmaX)/dfloat(nlamda)

         end subroutine
!---------------------------------------------------------------------
        subroutine offsetcorrection(expe0,expe)
         implicit none
         integer i,j
         real*8 XYexp0(nlamda),XYtheo(nlamda),aa(nd),bb(nd)
         real*8 wlength,expe0(nlamda,nd),expe(nlamda,nd)
         
         do i=1,nd
           do j=1,nlamda
            XYexp0(j)=expe0(j,i)
            call spectratot(Ntot(j),Nsub(j),Tbckg(j),dddbon(i),lamda(j),c(i),Xtheo(j,i))
            XYtheo(j)=Xtheo(j,i)
           enddo
           call chopab(XYtheo,XYexp0,aa(i),bb(i))
           do j=1,nlamda
             expe(j,i)=expe0(j,i)+aa(i)*lamda(j)+bb(i)
           enddo 
          enddo
        end subroutine offsetcorrection 
!---------------------------------------------------------------------
        subroutine optiD(dd)
         implicit none
         integer l,j
         real*8 merit,merit2, dd(nd),XYexp(nlamda),newd
        
         do l=1,nd
           do j=1,nlamda
             XYexp(j)=Xexp(j,l)
           enddo
           merit = funmeritL(dd(l),c(l),XYexp)
           call  steepestD(dd(l),c(l),XYexp,newd)
           merit2= funmeritL(newd,c(l),XYexp)
           if (merit2.lt.merit) dd(l)=newd
         enddo
        end subroutine optiD
!---------------------------------------------------------------------
        subroutine optiC(cc,lmin,lmax)
         implicit none
         integer l,j,lmin,lmax
         real*8 merit,merit2, cc(nd),XYexp(nlamda),newc

         do l=1,nd
           do j=1,nlamda
             XYexp(j)=Xexp(j,l)
           enddo
           merit = funmeritL2(dddbon(l),cc(l),XYexp,lmin,lmax)
           call  steepestC(dddbon(l),cc(l),XYexp,newc)
           merit2= funmeritL2(dddbon(l),newc,XYexp,lmin,lmax)
           if (merit2.lt.merit) cc(l)=newc
         enddo
        
        end subroutine optiC
!---------------------------------------------------------------------
        subroutine optiK(lamin,lamax)
         implicit none
         integer i,j,lamin,lamax
         real*8 merit,merit2, XYexp(nd),newk

         do i=lamin,lamax
           do j=1,nd
             XYexp(j)=Xexp(i,j)
           enddo
           merit = funmeritD(real(Ntot(i)),aimag(ntot(i)),Nsub(i),Tbckg(i),lamda(i),XYexp) 
           call steepestK(real(Ntot(i)),aimag(ntot(i)),Nsub(i),Tbckg(i),lamda(i),XYexp,newk)
           merit2= funmeritD(real(Ntot(i)),newk,Nsub(i),Tbckg(i),lamda(i),XYexp) 
           if (merit2.lt.merit) nktot(i)=newk
         enddo

        end subroutine optiK
!---------------------------------------------------------------------


end module netk 
